/****************************************************************/
/*								*/
/* RotorDRV ; Rotortreiberprogramm fuer Orbitdrv		*/
/*								*/
/****************************************************************/
/* mit Speichermodell "compact" bersetzen */

/* folgende Funktionen sind definiert:
	ah = 0x00	read status
	ah = 0x03	get position
	ah = 0x04	wie bei instanttrack beschrieben, setzt
			Azimut und Elevation. dx = Azimut, cx =
			Elevation.
	ah = 0x09	enable tracking
	ah = 0x7f	set flipmode
	ah = 0x7e	get flipmode
*/

#include <stdio.h>
#include <dos.h>
#include <alloc.h>
#include <time.h>


#define int_nr 0x63
#define Farbes 0x07
#define Farbeb 0x17

/* Setze near Heap & Stack kleiner */

extern unsigned _heaplen = 1024;
extern unsigned _stklen  =  512;


extern void interrupt rotorirq();


unsigned seg,ofs;
int ax,bx,cx,dx,lang,zeile=5,enabled=0,flipmode=0;
char stringnul[8]="       ";
char stringser[16],*punkt=".0";
unsigned char ah,al,cl,ch;
int azimuth=0,elevation=0;

/* Funktion Bildschirm beschreiben */
void bild(z,s,t,l,a)
char t[20];
{
int n, offs;
offs = (160 * --z) +( s * 2);
disable();
for(n = 0; n < l; n++)
	{
	pokeb(0xb800,offs++,t[n]);			//ASCII-Zeichen
	pokeb(0xb800,offs++,a);				//Farbe
	}
enable();
}



#define RBR 0x00	/* Empfangsregister		*/
#define DLL 0x00	/* Baudrate (LS) DLAB = 1	*/
#define IER 0x01	/* Interrupt enable DLAB = 0	*/
#define DLM 0x01	/* Baudrate (MS) DLAB = 1	*/
#define LCR 0x03	/* Leitungskontrollregister	*/
#define MCR 0x04	/* Modemkontrollregister	*/
#define LSR 0x05	/* Linestatusregister		*/
#define baudpar 0x03    /* 8 bit,no parity,1 stop	*/
#define bitrate 19200

/* fuer serielles I/O*/
int divisor=115200/bitrate,comp,com=0;
int comarr[4] = { 0x03f8,0x02f8,0x03e8,0x02e8 };

void serinit()
{
comp = comarr[com]; 		/* port number 0=com1 */
/* outportb((comp+IER), 0x00);	/* disable interrupts */
outportb((comp+LCR), 0x80);	/* DLAB=1*/
outportb((comp+DLL), (unsigned char) (divisor & 0x00ff)); /*low byte*/
outportb((comp+DLM), (unsigned char) (divisor & 0xff00) >> 8 );/*high byte*/
outportb((comp+LCR), baudpar);
outportb((comp+MCR), 0x03);	/*DTR,RTS*/
delay(10);
}

void comdrv(prefix,x,laenge)
char *x,*prefix;
{
int n;

	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[0]);
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[1]);
	for (n = 0; n < laenge; n++)
	{
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb( (comp+RBR), x[n] );
	}
}


void handler()
{
char stringe[16];

	ah = _AH;
	al = _AL;

asm sti;

if ( ah == 0x00 )
	{
	_AL=0;
	return;
	}
if ( ah == 0x03 )
	{
	_AX=cx;
	_BX=dx;
	_CX=cx;
	_DX=dx;
	return;
	}
if ( ah == 0x04)
	{
	cx = _CX;
	dx = _DX;
	if ( (cx<0) | (cx>90) | (dx<0) | (dx>359) )
		{

		if ( elevation !=cx )
		{
		elevation = cx;
		stringser[0]=0;
		strcat(stringser,"E");
		itoa(elevation,stringe,10);
		strcat(stringser,stringe);
		strcat(stringser," off;");
		comdrv("M:",stringser,strlen(stringser));
		}

		return;
		}

	if (flipmode == 1)
	{
	cx=180-cx;
	dx=(dx+180)%360;
	}

	if ( azimuth != dx )
	{
	azimuth = dx;
	itoa(azimuth,stringser,10);
	strcat(stringser,punkt);
	lang = strlen(stringser);
	comdrv("AZ",stringser,lang);
//	bild(zeile,70-lang,stringser,lang-2,Farbeb);
	}

	if ( elevation !=cx )
	{
	elevation = cx;
	itoa(elevation,stringser,10);
	strcat(stringser,punkt);
	lang = strlen(stringser);
	comdrv("EL",stringser,lang);
//	bild(zeile,74-lang,stringser,lang-2,Farbeb);
	}
	return;
	}
if ( ah == 0x09 )
	{
	enabled=_AL ;   	// 1: enable; 0;disable
//	if (enabled == 0) bild(zeile,65,stringnul,8,Farbes);
	return;
	}
if ( ah == 0x7f )
	{
	flipmode=_AL ;  	// 0:normal; 1:flip; -1:notset
	if (flipmode == 1)  comdrv("M:"," Flip_Mode on;",14);
	if (flipmode == 0)  comdrv("M:","Flip_Mode off;",14);
	return;
	}
if ( ah == 0x7e )
	{
	_AL=flipmode ;
	return;
	}
}


/* Hauptprogramm */
void main()
{

com=0;

if ( _argc > 1 ) com=atoi( _argv[1])-1;
while ( (com < 0) | (com > 3) )
	{
	printf ( "falsche COM-Port Nummer (1-4)");
	printf("\nInput COM-port (1-4):");
	gets(stringser);
	com= abs(atoi(stringser))-1;
	}


printf ( "benutztes Port: COM%d\n",com+1 );

/*setup serial i/o*/
serinit();
comdrv("M:"," Rotor_Driver;",14);
delay(1000); /* */

setvect(int_nr,rotorirq);
keep(0, (_SS + ((_SP+16)/16) - _psp));
}
